unit KbMPath;
{
 * NokomoDecoder
 * Copyright (c) 2005 Autch.net. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 *     Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 *     Neither the name of the Autch.net nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}

// KbMedia Player ̃pXo֐

interface

uses Windows, SysUtils, Forms, Dialogs, KbMD_Common;

	function GetPluginPath: string;

implementation

uses Registry, FileCtrl;

function GetPluginPath: string;
var
	RegKbm: TRegistry;
	KbMPath: string;
begin
	Result := SaveData.ReadString('SearchPath', 'Plugins', '');

	if (Result = '') or not FileExists(Result) then
	begin
		RegKbm := TRegistry.Create;
		try
			RegKbm.RootKey := HKEY_CURRENT_USER;
			if RegKbm.OpenKey('\Software\Kobarin''s Soft\KbMIDI Player\SearchPath', false) then
			begin
				KbMPath := ExtractFilePath(RegKbm.ReadString('Kbmplay'));
				RegKbm.CloseKey;
			end;
		finally
			RegKbm.Free;
		end;

    // pXȂƂ͐lԂɕ
		if KbMPath = '' then
		begin
			while true do
			begin
				Application.MessageBox('KbMedia PlayeriKbMPlay.exej̃pXw肵ĂB', 'KbMP pXw', 0);
				KbMPath := '.';
				if SelectDirectory(KbMPath, [], 0) = true then
				begin
					Result := KbMPath;
					if FileExists(IncludeTrailingPathDelimiter(Result) + 'kbmplay.exe') then
						break
				end
				else
				begin
					Application.Terminate;
					break;
				end;
			end;
		end
		else
			Result := IncludeTrailingPathDelimiter(KbMPath) + 'Plugins';

		SaveData.WriteString('SearchPath', 'Plugins', Result);
	end;
end;

end.
