unit KbMD_Common;
{
 * NokomoDecoder
 * Copyright (c) 2005 Autch.net. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 *     Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 *     Neither the name of the Autch.net nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}

// ̂͌ KbMedia Decoder ƂÔł̖c@
// AvP[V̋NƏIɐݒ̓ǂݏł悤
// initialization  finalization KvAꂾB

interface

uses Windows, SysUtils, Forms, Registry, Classes;

var
	SaveData: TRegIniFile;
	LogFile: TStringList;

const
	RegEntryName = 'Software\Autch\NokomoDecoder';

implementation

procedure InitializeSaveData;
begin
	SaveData := TRegIniFile.Create(RegEntryName);
end;

procedure FinalizeSaveData;
begin
	SaveData.Free;
end;

procedure InitializeLogger;
begin
	LogFile := TStringList.Create;
end;

procedure FinalizeLogger;
begin
{$IFOPT D+}
	if Assigned(LogFile) then LogFile.SaveToFile(ChangeFileExt(Application.ExeName, '.log'));
{$ENDIF}
	LogFile.Free;
end;

initialization
	InitializeSaveData;
	InitializeLogger;

finalization
	FinalizeSaveData;
	FinalizeLogger;

end.
