program NokomoDecode;
{
 * NokomoDecoder
 * Copyright (c) 2005 Autch.net. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 *     Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 *     Neither the name of the Autch.net nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}

{%File '߂.txt'}

uses
  Forms,
  MainWnd in 'MainWnd.pas' {frmMain},
  KPI in 'KPI.pas',
  kpiWrapper in 'kpiWrapper.pas',
  KpiSong in 'KpiSong.pas',
  kpiDriver in 'kpiDriver.pas',
  CriticalSection in 'CriticalSection.pas',
  KbMPath in 'KbMPath.pas',
  KbMD_Common in 'KbMD_Common.pas',
  kpiFileDecoderThread in 'kpiFileDecoderThread.pas',
  Version in 'Version.pas',
  SplashWnd in 'SplashWnd.pas' {frmSplash},
  SplashFrame in 'SplashFrame.pas' {fraSplash: TFrame},
  kpiEffector in 'kpiEffector.pas',
  kpiEffectorPlugin in 'kpiEffectorPlugin.pas',
  kpiPlayListReader in 'kpiPlayListReader.pas';

{$R *.res}

begin
  Application.Initialize;
  Application.Title := '̂ Decoder';
	Application.CreateForm(TfrmMain, frmMain);
  Application.ShowMainForm := false;
  Application.Run;
end.
